<?
/*
* Plugin Name: Crew Manager
* File availability-shortcode.php
* File Version 1.1.0 Beta
* Inserts [availability] shortcode to allow logged in crew to set
* availability for currrent year events.
* Triggers email to Skipper if anyone changes availability.
* Crew Members are WP subscribers
*
* 5/23/2018 added jump to next scheduled event button
* 5/10/2018 fixed "&#8217;" instead of "'" in notification email
* 5/3/2018 fixed "&#8211;" instead of "-" in notification email
* 4/28/2018 Submit button now floats
* 4/25/2018 updated screen format to match [assignments]
* 4/18/2018 changed time zone correction to use date_default_timezone_set($tz)

* Author: Bill Kneller
* Author URI: http://crew-mgr.com
**/

function content_availability($atts, $content_availability = null){
$debug_displays = ""; // "Yes" turns on debug displays, otherwise ""
$debug_stop_database_update  = ""; // "Yes" prevents db update, otherwise ""
$debug_email_single_admin_only  = ""; // "Yes" only emails selected admin, otherwise ""
if($debug_displays) $show_debug_displays = "Debug Displays Enabled";
if($debug_stop_database_update) $show_debug_stop_database_update = "Database Updates Inhibited";
global $crew_manager_options; // allows setup options from admin panel
if($debug_email_single_admin_only) {
  $show_debug_email_single_admin_only = "Emails only going to 1 Admin User";
  $crew_administrators = get_user_email($crew_manager_options['skipper']); // single admin emails for debug
}
if ($debug_email_single_admin_only || $debug_displays || $debug_stop_database_update)$table .= "<h3>".$show_debug_displays . "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;". $show_debug_email_single_admin_only . "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;". $show_debug_stop_database_update ."</h3><br>";
$crew_administrators = get_user_email($crew_manager_options['skipper']); // admin for email notification if defined in admin panel
if (get_user_email($crew_manager_options['skipper_admin'])) $crew_administrators .=", ". get_user_email($crew_manager_options['skipper_admin']); // adds second admin for email notification if defined in admin panel


$current_user = wp_get_current_user(); // gets user logged in
$cur_yr = date('Y'); // gets curent year for query
$table_bgcolor="#EAF2F8"; // light blue background on selected table rows

// Get the data from the ai1ec_events table in the Wordpress database.
global $wpdb;
    $table_ai1ec_events  = $wpdb->prefix."ai1ec_events";
    $table_ai1ec_instances  = $wpdb->prefix."ai1ec_event_instances";
    $table_crewmgr_assigned  = $wpdb->prefix."crewmgr_assigned";
    $table_crewmgr_position  = $wpdb->prefix."crewmgr_position";
    $table_users  = $wpdb->prefix."users";
    $table_posts  = $wpdb->prefix."posts";

$crewquery = $wpdb->get_results("SELECT DISTINCT e.start 'Start', e.end 'End', e.venue 'Location', p.post_title 'Event', p.ID 'PostID', u.display_name 'Name', u.ID 'ID' FROM $table_ai1ec_events e, $table_ai1ec_instances i, $table_users u, $table_posts p 
WHERE e.post_id = p.ID
AND e.post_id = i.post_id
AND p.post_status = 'publish'
AND $current_user->ID = u.ID 

AND FROM_UNIXTIME(e.start, '%Y') = $cur_yr
GROUP BY p.ID
ORDER BY e.start
", ARRAY_A);
    $table ="<form action=\"\" method=\"post\">";
    $table .="<div class=\"button-login-redirect\"><center><a class=\"button-login-redirect\" href=\"#jump_here\">Jump to Next Scheduled Event</a></center></div>"; // button jumps to next event date
    $table .="<b>Crew Member Logged in: </b>".$current_user->user_login."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  <b>User ID: </b>".$current_user->ID."&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; (".$current_user->user_firstname  ." ".$current_user->user_lastname.")";
    $table .="<table width=\"100%\"  frame=\"box\" border=\"1\" cellspacing=\"0\" cellpadding=\"0\">";
    $table .= "<tr><td colspan=\"6\"><center><b>Change availability for events - Choose <em>Availabile</em> dropdown for events you want to change => Scroll to bottom => Click <em>Submit Changes</em></b></center></td></tr>";

    $table .= "<td colspan=\"6\"><b>Crew Color Codes:</b> Green crew is confirmed. Yellow crew need to verify with Skipper.  Red does not crew for event.  White crew position assignment not made yet.</td>";
    $table .= "<tr style=\"background-color:".$table_bgcolor.";\"  ><td><b>Event</b></td><td width=\"15%\"><b>Date</b></td><td width=\"10%\"><b>Time</b></td><td><b>Location</b></td><td><b>Position Assigned</b></td><td align = \"center\" width=\"20%\"><b>Available</b></td></tr>";
$jump_flag = NULL;
$date = new DateTime();
$now = $date->getTimestamp();
foreach($crewquery as $row)
{
    // display each $row from query here.
$pos = get_position($current_user->ID, $row['PostID']);
     if ($current_user->ID == $row['ID']){ $available_dropdown = load_available_dropdown(0,0,$current_user->ID,$row['PostID']);
} // end foreach($crewquery as $row)
     $available = initial_dropdown_value(0, 0, $current_user->ID, $row['PostID']);

     $bgcolor="#ffffff"; // white  
     if($available=="3" || $pos=="Stay Ashore") $bgcolor="#ffccff"; // pink  
     if($available=="1" && $pos=="Standby Crew") $bgcolor="#ffff99"; // yellow  
     if($available=="2") $bgcolor="#ffff99"; // yellow
     if($available=="1" && ($pos!="Not Assigned" && $pos!="Standby Crew")) $bgcolor="#C2FFC2"; // green
     if(($available=="1") && $pos=="Not Assigned") $bgcolor="#ffffff"; // white
     if($pos=="Stay Ashore") $bgcolor="#ffccff"; // pink  
global $crew_manager_options; // allows global [time_offset] and [availability_hide] in query
$tz = $crew_manager_options['time_zone'];
date_default_timezone_set($tz); //Corrects for local
     $event_date=date("D, M jS", $row['Start']);
     $event_time=date("g:i A", $row['Start']);
     $Jump_URL='';
     $Event_URL='<a href="'.get_permalink( $row['PostID'] ).'">'.get_the_title( $row['PostID'] ).'</a>';
// this section sets page link so that on page load the next date is scrolled to
	if (($row['Start'] - $now) == abs(($row['Start'] - $now)) && $jump_flag!==1)
	 {
     $Jump_URL='<a name="jump_here"></a>';
	 $jump_flag = 1; }
 // this is first date after $now so put jump tag in url
     $table .= "<tr><td bgcolor=$bgcolor>". $Jump_URL .$Event_URL . "</td><td bgcolor=$bgcolor>". $event_date . "</td><td bgcolor=$bgcolor>". $event_time . "</td><td bgcolor=$bgcolor>". $row['Location'] . "</td><td bgcolor=$bgcolor>".$pos."</td><td bgcolor=$bgcolor align = \"center\">".$available_dropdown."</td></tr>";
}
    $table .="</table>";
/** Below starts the submit button **/
    $table .="<div class=\"floatingbox\" id=\"floatingbox\"><input type=\"submit\" name=\"Submit\" value=\"Submit Changes\"</div>"; // button floats
//    $table .="<TD><font color=\"#FFFFFF\"><center><b><input type=\"submit\" name=\"Submit\" value=\"Submit Availability Change\"></b></center></font></TD>"; // previous fixed button
    $table .="</form>";
// below checks if availability was changed which forces a database update
if(isset($_POST['available'])){
$available = $_POST['available'];  //sets up array with all dropdown values

// echo "<br><center><h2>Submit Clicked</h2></center><br>"; //debug
$notification_email=""; // start empty message
    $table_name  = $wpdb->prefix."crewmgr_assigned";
foreach($available as $key => $avail_value) {
      	$avail_key=$key;
    //function called with query to insert or update;
    //Gets array $key (id) and $value (available);
  $PostID = substr($key, 0, strpos($key, "-")); // key has post and user id - strip user
  $position_id = get_position_id($current_user->ID, $PostID);
  $assigned = get_assigned_text($current_user->ID, $PostID);
  $avail_stored = get_available_id($current_user->ID, $PostID);
if(get_available_text($avail_stored) != get_available_text($avail_value)){ // this means no change so skip updating
$notification_email .=$current_user->user_firstname  ." ". $current_user->user_lastname . " changed availability from ". get_available_text($avail_stored) . " to " . get_available_text($avail_value) . " for " .get_the_title( $key ). " scheduled ". get_event_start_date($PostID) . "<br>";


if ($debug_displays)   echo "PostID: ".$PostID. "  Key: ".$key."  Curent User ID: ".$current_user->ID."  Value: ".$avail_value."  Previous Value: ".$avail_stored."  Position ID: ".$position_id."<br>";  // debug
    if (!$debug_stop_database_update)  $db_update = availability_insert_or_update($PostID, $current_user->ID, $avail_value, $position_id, $assigned);
} // endif
    } // end foreach $available
$notification_email = str_replace("&#8211;", "-", $notification_email); // puts dash in for ascii code
$notification_email = str_replace("&#8217;", "'", $notification_email); // puts single quote in for ascii code
if ($debug_displays) echo "Text for email:<br>".$notification_email . "<br>"; // debug
if (!$debug_stop_email) { // debug turn off emails
$user_info = get_userdata( $crew_manager_options['skipper'] );
$from_email = $user_info->user_email;
$skipper_name = $user_info->first_name." ".$user_info->last_name;
$headers[] = 'Content-Type: text/html; charset=UTF-8';
$headers[] = "From: ".$skipper_name." <".$from_email.">";
 if ($notification_email) wp_mail($crew_administrators, get_bloginfo() . " Crew Member Availability Change", $notification_email, $headers); // sends notification email with any availability changes
} // end if debug turn off emails
     echo "<h3><font color=\"red\"><center>Refreshing Display</center></font></h3>";

if (!$debug_displays)  $table .="<meta http-equiv='refresh' content='0'>";  // comment out for debug
}
// This is the end of the submit button update section

    if($current_user->ID!=0){ // display table only if logged in
        return $table;
    }else{
    $table ="<h4>Crew Members - Please <a href=\"".wp_login_url( get_permalink() )."\" title=\"Login\">Login</a> to view / set your availability for current year events.</h4>";
        return $table;
    }
}

add_shortcode('availability', 'content_availability');

// end of [availability] shortcode ***************************
