<?
/*
* Plugin Name: Crew Manager
* File weight-shortcode.php
* File Version 1.1.0 Beta
* Author: Bill Kneller
* Author URI: http://crew-mgr.com
* Inserts [weight] shortcode to allow logged in skipper to view
* a regatta report for weight and sailor classification status. 
* Includes links to user profiles for editing if desired.
* 6/24/2018 added World Sailing Database validation of Sailor Slassification
* 6/18/2018 Originated
*/

function content_weight($atts, $content_weight = null){
$current_user = wp_get_current_user(); // gets user logged in
$cur_yr = date('Y'); // gets curent year for query

if (isset($_SESSION['regatta'])) $post_id = $_SESSION['regatta'];
if(isset($_POST['regatta'])){
// save regatta selected for page submission refresh 
$_SESSION['regatta'] = $_POST['regatta'];
$post_id = $_SESSION['regatta']; // get the selected crew from dropdown
}

     $table ="<form action=\"\" method=\"post\">";
     $table .= "<table>";
     $table .= "<td align = \"center\" width=\"25%\">".get_regatta_dropdown($post_id)."</td><td><input type=\"submit\" name=\"RegattaSubmit\" value=\"<=Select Regatta & Click Here to Update\"></td>";
if(isset($_POST['regatta'])){
     $table .= "<tr><td colspan=\"6\"><input type=\"checkbox\" name=\"isaf_check\" value=\"Yes\" /><b> <= Check Box to Validate Sailor Classification, then resubmit above </b> - May take a minute to update display while validating data in World Sailing database.</td></tr>";
}
    $table .="</table>";
    $table .="</form>";
if(isset($_POST['crew'])){
// save crew selected for page submission refresh 
$_SESSION['regatta'] = $_POST['regatta'];
$post_id = $_SESSION['regatta']; // get the selected regatta from dropdown
}
// above is end of RegattaSubmit
$sailor_classification_header = "Declared Sailor Classification"; 
if(isset($_POST['isaf_check'])) { 
$check_isaf = 1; // sets flag to check the isaf database
$sailor_classification_header = "Validated Sailor Classification"; 
}

    if($current_user->ID!=0){ // display table only if logged in
// Get the data from the ai1ec_events table in the Wordpress database.
     global $crew_manager_options; // allows global [time_offset] and [availability_hide] in query
$tz = $crew_manager_options['time_zone'];
date_default_timezone_set($tz); //Corrects for local
     $event_date=date("D, M jS", $row['Start']);

     $Event_URL='<a href="'.get_permalink( $post_id ).'">'.get_the_title( $post_id ).'</a>';

global $wpdb;
    $table_ai1ec_events  = $wpdb->prefix."ai1ec_events";
    $table_crewmgr_assigned  = $wpdb->prefix."crewmgr_assigned";
    $table_crewmgr_position  = $wpdb->prefix."crewmgr_position";
    $table_users  = $wpdb->prefix."users";
    $table_usermeta  = $wpdb->prefix."usermeta";
    $table_posts  = $wpdb->prefix."posts";
$crewquery = $wpdb->get_results("SELECT `u`.ID 'ID', cmp.position 'Position', cmp.position_id 'PosID', `cma`.available 'Available', cma.id 'AvailID', e.post_id 'PostID'  FROM `$table_ai1ec_events` `e`, `$table_crewmgr_assigned` `cma`, $table_crewmgr_position cmp, `$table_users` `u`, `$table_usermeta` `m`    
WHERE `e`.post_id = '$post_id' AND `cma`.ai1ec_post_id = '$post_id'
AND cma.position_id = cmp.position_id
AND `u`.ID = `cma`.user_ID
AND `u`.ID = `m`.user_id
GROUP BY `u`.ID
ORDER BY `cma`.available, `u`.display_name
", ARRAY_A);
$rowcount = $wpdb->num_rows;
    $table .="<table width=\"100%\"  border=\"1\" cellspacing=\"0\" cellpadding=\"0\">";
    $table .= "<tr><td colspan=\"6\"><center><b><h2>$Event_URL</h2></b></center></td></tr>";
    $table .= "<td colspan=\"6\">Only confirmed crew who are available and assigned a position are inlcuded in the weight report.</td>";
    $table .= "<tr><td><b>Name</b></td><td align = \"center\"><b>Weight (lbs)</b></td><td><b>Position</b></td><td><b>Sailor ID</b></td><td><b>" . $sailor_classification_header . "</b></td><td><b>US Sailing #</b></td></tr>";
	$weight_total=$counter=0; // initialze summation
		foreach( $crewquery as $row ){



	     $bgcolor="#ffffff"; // white  
	     if($row['Available']=="1" && $row['Position']!=="Stay Ashore" && $row['Position']!=="Standby Crew") { // only include crew available and assigned a position who are not told to Stay Ashore or Standby Crew  
	     $bgcolor="#C2FFC2"; // green
     	 $colordot="<span class=\"greendot\"></span>";
			$user_id = $row['ID'];
			$user_info = get_userdata( $user_id );
			$user_meta = get_user_meta( $user_id );
$classification = "";
			IF ($user_info->isaf_classification == 3) $classification = "Group 3 (Professional)";
			IF ($user_info->isaf_classification == 1) $classification = "Group 1 (Amateur)";
			$weight = $user_info->weight;
			$pos=get_position($user_id, $post_id);
			$isaf_link = $user_info->isaf_number;
			$weight_total = $weight + $weight_total;
			IF ($user_info->isaf_number && $check_isaf) { // get ISAF data if number is recorded
			$isaf_link = $classification = $status = "";
			$url = 'http://datafeed.sailing.org/query?type=Person&IFPersonID=' . $user_info->isaf_number;
			$xml = simplexml_load_file($url) or die("feed not loading");
			$ISAF_ID = $xml->Person[0]['IFPersonID'];
			$ISAF_Group = $xml->Person[0]['ClassificationGroup'];
			$ISAF_Expiry = date("m/d/Y", strtotime($xml->Person[0]['ClassificationExpiry']));
			$ISAF_Status = $xml->Person[0]['ClassificationStatus'];
			$ISAF_Name = $xml->Person[0]['GivenName'] . " " . $xml->Person[0]['FamilyName'];
			$ISAF_URL = "http://www.sailing.org/sailors/biog.php?isafid=" . $xml->Person[0]['IFPersonID'] . "&panel=results#content";
//  echo "ID: " . $ISAF_ID . "  Group: " . $ISAF_Group . "  Expiry: " . $ISAF_Expiry ."  Status: " . $ISAF_Status ."  Name: " . $ISAF_Name ."  URL: " . $ISAF_URL ."<br>"; // debug
			$isaf_link="<a class='link' href=\"".$ISAF_URL."\" target=\"_blank\">".$ISAF_ID . "</a>"; // display with link to edit user profile

			IF ( trim(strtoupper($user_info->last_name)) !== trim(strtoupper($xml->Person[0]['FamilyName'])) ) $isaf_link .= " Invalid";
			IF ($ISAF_Status == "Expired") $status = " - Expired " . $ISAF_Expiry;
			IF ($ISAF_Status == "Current") $status = " - Current through " . $ISAF_Expiry;
			IF ($ISAF_Group == 1) $classification = "Group 1 (Amateur)". $status;
			IF ($ISAF_Group == 3) $classification = "Group 3 (Professional)". $status;

			} // END IF ($user_info->isaf_number)
	if ($crew_manager_options['include_helm'] == 1 && $crew_manager_options['weight_limit'] !== 0 && $pos == "Helm" ) $weight_total = $weight_total - $weight; // subtract helm weight

 $profile_link="<a class='link' href=\"".admin_url( 'user-edit.php?user_id=' . $user_id, 'http' )."\" target=\"_blank\">".$user_info->first_name." ".$user_info->last_name . "</a>"; // display with link to edit user profile

			$counter++;
     $table .= "<tr><td bgcolor=$bgcolor>". $colordot . " " . $counter . " " . $profile_link . "</td><td bgcolor=$bgcolor align = \"center\">". $user_info->weight . "</td><td bgcolor=$bgcolor>". $pos . "</td><td bgcolor=$bgcolor>". $isaf_link . "</td><td bgcolor=$bgcolor>". $classification . "</td><td bgcolor=$bgcolor>". $user_info->ussailing . "</td></tr>";
		 	     } // end if($row['Available']..)
		} // end foreach $crewquery
	$allowed_weight = $crew_manager_options['weight_limit'];
	if ($crew_manager_options['include_helm'] == 1 ) $helmsman_in_or_out = "  Helmsman weight is excluded from total.";

	$delta = $weight_total - $allowed_weight;
	$message = "= " . -$delta . " lbs under " . $allowed_weight . " lb limit. " . $helmsman_in_or_out;
	if ($delta >= 0 ) $message = "= " . $delta . " lbs over " . $allowed_weight . " lb limit. " . $helmsman_in_or_out;
	if ($crew_manager_options['weight_limit'] == 0 ) $message = "There is no weight limit";
if ($rowcount - $counter >>0 ) { // show additional crew if status was found in the query
$yes='<img src="'.plugins_url().'/crew-manager/images/checked.gif">';
$no = '<img src="'.plugins_url().'/crew-manager/images/unchecked.gif">';
     $table .= "<tr><td align = \"right\" >Total: </td><td align = \"center\" >". $weight_total . "</td><td colspan=\"4\">" . $message . "</td></tr>";
     $table .= "<tr><td colspan=\"6\"><br><h3><center>Other Crew Listed for Event</center></h3></td></tr>";
    $table .= "<td colspan=\"6\"><b>Crew Availability Codes:</b> " . $yes . " Crew is Available &nbsp;&nbsp;&nbsp;&nbsp;<b>?</b> Crew Maybe Available  &nbsp;&nbsp;&nbsp;&nbsp;" . $no . "Crew is Not Available</td>";
		foreach( $crewquery as $row ){
	     $bgcolor="#ffffff"; // white  
	     if(!($row['Available']=="1" && $row['Position']!=="Stay Ashore" && $row['Position']!=="Standby Crew")) { // only include crew not in list above
	     if($row['Available']=="3" || $row['Position']=="Stay Ashore") $bgcolor="#ffccff"; // pink  
    	 if($row['Available']=="1" && $row['Position']=="Standby Crew") $bgcolor="#ffff99"; // yellow 
	     if($row['Available']=="2") $bgcolor="#ffff99"; // yellow
	     if(($row['Available']=="1" || $row['Available']=="2") && $row['Position']=="Not Assigned") $bgcolor="#ffffff"; // white
	     if($row['Position']=="Stay Ashore") $bgcolor="#ffccff"; // pink  
     if($row['Available']==1) $available='<img src="'.plugins_url().'/crew-manager/images/checked.gif">';
     if($row['Available']=="2") $available='<b>?</b>';
     if($row['Available']=="3") $available='<img src="'.plugins_url().'/crew-manager/images/unchecked.gif">';
			$user_id = $row['ID'];
			$user_info = get_userdata( $user_id );
			$user_meta = get_user_meta( $user_id );
$classification = "";
			IF ($user_info->isaf_classification == 3) $classification = "Group 3 (Professional)";
			IF ($user_info->isaf_classification == 1) $classification = "Group 1 (Amateur)";
			$weight = $user_info->weight;
			$pos=get_position($user_id, $post_id);
			$isaf_link = $user_info->isaf_number;
			IF ($user_info->isaf_number && $check_isaf) { // get ISAF data if number is recorded
			$isaf_link = $classification = $status = "";
			$url = 'http://datafeed.sailing.org/query?type=Person&IFPersonID=' . $user_info->isaf_number;
			$xml = simplexml_load_file($url) or die("feed not loading");
			$ISAF_ID = $xml->Person[0]['IFPersonID'];
			$ISAF_Group = $xml->Person[0]['ClassificationGroup'];
			$ISAF_Expiry = date("m/d/Y", strtotime($xml->Person[0]['ClassificationExpiry']));
			$ISAF_Status = $xml->Person[0]['ClassificationStatus'];
			$ISAF_Name = $xml->Person[0]['GivenName'] . " " . $xml->Person[0]['FamilyName'];
			$ISAF_URL = "http://www.sailing.org/sailors/biog.php?isafid=" . $xml->Person[0]['IFPersonID'] . "&panel=results#content";
//  echo "ID: " . $ISAF_ID . "  Group: " . $ISAF_Group . "  Expiry: " . $ISAF_Expiry ."  Status: " . $ISAF_Status ."  Name: " . $ISAF_Name ."  URL: " . $ISAF_URL ."<br>";
			$isaf_link="<a class='link' href=\"".$ISAF_URL."\" target=\"_blank\">".$ISAF_ID . "</a>"; // display with link to edit user profile

			IF ( trim(strtoupper($user_info->last_name)) !== trim(strtoupper($xml->Person[0]['FamilyName'])) ) $isaf_link .= " Invalid";
			IF ($ISAF_Status == "Expired") $status = " - Expired " . $ISAF_Expiry;
			IF ($ISAF_Status == "Current") $status = " - Current through " . $ISAF_Expiry;
			IF ($ISAF_Group == 1) $classification = "Group 1 (Amateur)". $status;
			IF ($ISAF_Group == 3) $classification = "Group 3 (Professional)". $status;

			} // END IF ($user_info->isaf_number)
 $profile_link="<a class='link' href=\"".admin_url( 'user-edit.php?user_id=' . $user_id, 'http' )."\" target=\"_blank\">".$user_info->first_name." ".$user_info->last_name . "</a>"; // display with link to edit user profile

     $table .= "<tr><td bgcolor=$bgcolor>". $available . " " . $profile_link . "</td><td bgcolor=$bgcolor align = \"center\">". $user_info->weight . "</td><td bgcolor=$bgcolor>". $pos . "</td><td bgcolor=$bgcolor>". $isaf_link . "</td><td bgcolor=$bgcolor>". $classification . "</td><td bgcolor=$bgcolor>". $user_info->ussailing . "</td></tr>";
		 	     } // end if($row['Available']....)
		} // end foreach $crewquery
	} // end if ($rowcount - $counter >>0 to get additional crew for display

    $table .="</table>";
     global $crew_manager_options; 
    if($current_user->ID == (int)$crew_manager_options['skipper'] || (int)$current_user->ID == $crew_manager_options['skipper_admin'] || current_user_can('administrator')){ // display table only if logged in as admin

        return $table;
} // endif logged in check from way above

    }else{
    $table ="<h3>Only the Skipper can see this page</h3>";
    $table .="<h4>Skipper - Please <a href=\"".wp_login_url( get_permalink() )."\" title=\"Login\">Login</a> to view a crew weight and sailor classification report.</h4>";
        return $table;
    }
}

add_shortcode('weight', 'content_weight');
// end of [weight] shortcode ***************************
